<?php
/**************************************************************
* Original Author:
* DataFeedFile.com (DFF) Framework API
* Licensed using GNU GPL
*
**************************************************************/
//Wiki documentation: http://wiki.datafeedfile.com//wikka.php?wakka=DFFgetfeaturedprdtfromPSEparam

require_once $DFF_config['dir_include'].'DFF_category1.array.php';

function DFF_get_featured_prdt_from_PSE($catnum = 'RANDOM', $keyword = FALSE, $mernum = FALSE, $sortby = FALSE, $limit = 20){
	global $DFF_category1_array;

	//PROCESS CATNUM FILTERING
	if($catnum == 'RANDOM'){
		//PICK ONE RANDOM CAT1NUM
		$categories1 = $DFF_category1_array;
		while(true){
			shuffle($categories1);
			if($categories1[0]['cat1num']!=1838 && $categories1[0]['cat1num']!=2327){
				$catnum = $categories1[0]['cat1num'];
				break;
			}
		}
	} elseif(intval($catnum) > 0){
		$catnum = intval($catnum);
	}
	
	//PROCESS MERNUM FILTERING (will support RANDOM in future once data caching on client side are working)
	if(intval($mernum) > 99){
		$mernum = intval($mernum);
	}
	
	//PROCESS LIMIT
	$limit = intval($limit);
	if($limit<=0) $limit = 20;
		elseif($limit>100) $limit = 100;

	//GET FEATURED PRODUCTS BY CATEGORY
	$dff_request = new DFF_Client_API;
	$dff_request->set_using_DFF_config();
	if($catnum!==FALSE) $pse_params['cat1num'] = $catnum;
	if($keyword!==FALSE) $pse_params['keyword'] = trim($keyword);
	if($mernum!==FALSE) $pse_params['mernum'] = $mernum;
	if($sortby!==FALSE) $pse_params['sortby'] = trim($sortby);
	$pse_params['limit'] = $limit;
	$result = $dff_request->post_request(DFF_PSE,$pse_params);
	$dff_request->convert_json_to_array();
	return $dff_request->result_array['productlist'];

}

function DFF_get_top_random_products_per_category($catnum = 'ALL', $limit_per_category = 1){
	
	//GET DFF TOP RANDOM PRODUCTS PER CATEGORY

   //PROCESS LIMIT
   $limit_per_category = intval($limit_per_category);
   if($limit_per_category<=0) $limit_per_category = 1;
      elseif($limit_per_category>100) $limit_per_category = 100;

   //GET FEATURED PRODUCTS BY CATEGORY
   $dff_request = new DFF_Client_API;
   $dff_request->set_using_DFF_config();
   
   if($catnum!==FALSE) $gen_params['cat1num'] = $catnum;
   $gen_params['limit_per_category'] = $limit_per_category;
   $gen_params['function'] = 'top_random_products_per_category';
   $gen_params['debug'] = 1;
   
   if($dff_request->post_request(DFF_GENERAL,$gen_params) !== FALSE) {
      $dff_request->convert_json_to_array();
      //echo "result_array:<pre>".print_r($dff_request->result_array,TRUE)."</pre>";
      return $dff_request->result_array;
   }
   
   return FALSE;
	
}
?>