<?php
/**************************************************************
* Original Author:
* DataFeedFile.com (DFF) Framework API
* Licensed using GNU GPL
*
**************************************************************/

// Featured Product
if ($_POST['DFF_WP_FP_option_hidden'] == 'Y')
{
	file_put_contents(DFF_FP_DIRNAME . '/style/user.featured.css', $_POST['DFF_WP_FP_css']);
	echo '<div class="updated"><p><strong>Options Saved.</strong></p></div>';
}

//Normal page display
$DFF_WP_aff_id = get_option('DFF_WP_FP_affid');
$DFF_WP_token = get_option('DFF_WP_FP_token');

// GET DFF AFFILIATE ID, IF NOT SET USE 1001
$tmp = get_option('DFF_WP_FP_affid');
$DFF_WP_affid = ($tmp > 0) ? $tmp : 1001;

?>

<style type="text/css">
code.shortcode {
	font-size: 14pt;
	line-height: 1.1em;
}

#scparams .name {
	width: 75px;
	text-align: left;
}
#scparams .possible {
	width: 150px;
	text-align: center;
}
#scparams .default {
	width: 100px;
	text-align: center;
}

#scparams td {
	border: 1px solid #999;
	padding: 5px;
}
</style>

<div class="wrap">
<?php echo "<h2>" . __( 'Featured Product - DataFeedFile.com (DFF)', 'DFF_WP_FP_trdom' ) . "</h2>"; ?>
<h3>Examples</h3>
<p>Default Settings</p>
<code class="shortcode">[DFF_WP_FP product_sku="[Insert DFF Product SKU]"]</code>
<p>All parameters given: Vertical Layout, Aligned Right, No Description, Limit to 1 (Lowest) Price</p>
<code class="shortcode">[DFF_WP_FP product_sku="[Insert DFF Product SKU]" layout="vertical" alignment="right" hide_desc="true" mer_limit="10"]</code>
<br /><br />
<hr />

<h4>Shortcode Parameters:</h4>
<table id="scparams">
<tr>
	<th>Name</th>
	<th>Description</th>
	<th>Possible Values</th>
	<th>Default Value</th>
</tr>
<tr>
	<td class="name">corenum</td>
	<td class="desc">Choose a DataFeedFile.com Product SKU number.</td>
	<td class="possible"><a href="http://www.datafeedfile.com/affiliate_search.php" target="_blank">Find a DFF Product SKU</a></td>
	<td class="default">0</td>
</tr>
<tr>
	<td class="name">mernum</td>
	<td class="desc">Choose a DataFeedFile.com Product SKU number. (Used in conjunction with '</td>
	<td class="possible"><a href="http://www.datafeedfile.com/affiliate_search.php" target="_blank">Find a DFF Product SKU</a></td>
	<td class="default">0</td>
</tr>
<tr>
	<td class="name">mersku</td>
	<td class="desc">Choose a DataFeedFile.com Product SKU number.</td>
	<td class="possible"><a href="http://www.datafeedfile.com/affiliate_search.php" target="_blank">Find a DFF Product SKU</a></td>
	<td class="default">0</td>
</tr>
<tr>
	<td class="name">layout</td>
	<td class="desc">Choose the layout scheme for the Featured Product region.</td>
	<td class="possible">horizontal, vertical</td>
	<td class="default">horizontal</td>
</tr>
<tr>
	<td class="name">alignment</td>
	<td class="desc">Choose what side of the post that the FP region will be displayed (only applies to vertical layout scheme)</td>
	<td class="possible">left, right</td>
	<td class="default">left</td>
</tr>
<tr>
	<td class="name">hide_desc</td>
	<td class="desc">Choose whether or not to show the description. (Sometimes this is close to a duplication of the Title itself)</td>
	<td class="possible">true, false</td>
	<td class="default">false</td>
</tr>
<tr>
	<td class="name">mer_limit</td>
	<td class="desc">Choose how many merchants will be shown in the FP region. (Merchants are sorted by lowest price first, so using a value of '1' will show the lowest price only)</td>
	<td class="possible">[integer]</td>
	<td class="default">5</td>
</tr>
<tr>
	<td class="name">target_blank</td>
	<td class="desc">Determine whether not clicking a link will open a new page. (If set to true, it will add <code>target="_blank"</code> to the link)</td>
	<td class="possible">true, false</td>
	<td class="default">true</td>
</tr>
</table>

<br />
<hr />

<form name="DFF_WP_FP_option_form" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">

	<input type="hidden" name="DFF_WP_FP_option_hidden" value="Y">

	<h4>Styling &amp; Design Customization:</h4>
	<p>Featured Product shortcode output will inherit the style of your blog template. You can also further override the CSS element by specifying your own CSS here.</p>
	<textarea name="DFF_WP_FP_css" cols="100" rows="25"><?php echo file_get_contents(DFF_FP_DIRNAME . '/style/user.featured.css'); ?></textarea>

	<h4>DFF Stylesheet</h4>
	<textarea name="DFF_WP_FP_css_default" cols="100" rows="25" readonly><?php echo file_get_contents(DFF_FP_DIRNAME . '/style/dff.featured.css'); ?></textarea>
	<hr />

	<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options', 'DFF_WP_FP_trdom' ) ?>" /></p>

</form>

</div>

