<?php
/*
Plugin Name: [DFF] DataFeedFile.com Featured Product
Plugin URI: http://wordpress.datafeedfile.com
Description: Using DataFeedFile's web services, feature a particular item within your blog and you can earn some of the profit when someone click's through and purchases that product.
Author: DataFeedFile.com
Version: 0.5b
Author URI: http://wwww.datafeedfile.com
*/
/**************************************************************
* Original Author:
* DataFeedFile.com (DFF) Framework API
* Licensed using GNU GPL
**************************************************************/

# Specify that we are using caching
define('WP_CACHE', true);
define('DFF_CACHE_TIME', get_option('DFF_WP_FP_cache_time'));

// MAIN PLUGIN FILE
define('DFF_FP_DIRNAME', dirname(__FILE__));
define('DFF_FP_URLPATH', WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__)) . '/');

include_once(DFF_FP_DIRNAME . "/DFF_WP_plugin_featuredProduct.php");

function DFF_WP_FP_admin_main() {
   include('DFF_WP_admin_main.php');
}

function DFF_WP_FP_admin_setting() {
   include('DFF_WP_admin_setting.php');
}

function DFF_WP_FP_admin_featuredProduct() {
   include('DFF_WP_admin_featuredProduct.php');
}

function DFF_WP_FP_admin_actions() {
	add_menu_page('DataFeedFile.com', '[DFF] Featured', 8, 'DFF_WP_FP_admin_main', '');
	add_submenu_page('DFF_WP_FP_admin_main', 'Settings: DFF Featured Product', 'Settings', 8, 'DFF_WP_FP_admin_main', 'DFF_WP_FP_admin_setting');
	add_submenu_page('DFF_WP_FP_admin_main', 'Admin: Featured Product', 'Featured Product', 8, 'DFF_WP_FP_admin_featuredProduct', 'DFF_WP_FP_admin_featuredProduct');
}

add_action('admin_menu', 'DFF_WP_FP_admin_actions');


///////////////////////////
//	Activation/Deactivation Hooks
///////////////////////////
function DFF_WP_FP_activation() {
	$options = Array(
		'DFF_WP_FP_affid' => false,
		'DFF_WP_FP_token' => false,
		'DFF_WP_FP_server_url' => 'http://www.datafeedfile.com/',
		'DFF_WP_FP_api_url' => 'http://www.datafeedfile.com/rest',
		'DFF_WP_FP_cache_time' => 10800
	);

	foreach ($options AS $key => $value)
	{
		add_option($key, $value);
	}
}

register_activation_hook(__FILE__, 'DFF_WP_FP_activation');


///////////////////////////
//	TinyMCE Integration
///////////////////////////
require_once(DFF_FP_DIRNAME . '/tinymce/tinymce.php');


///////////////////////////
//	Shortcode Implementation
///////////////////////////
add_shortcode('DFF_WP_FP', 'DFF_WP_FP_shortcode_display');
function DFF_WP_FP_sc_css() {
	echo '<link rel="stylesheet" type="text/css" href="'. DFF_FP_URLPATH . 'style/dff.featured.css' .'" />';

	if (file_get_contents(DFF_FP_DIRNAME . '/style/user.featured.css') != '')
		echo '<link rel="stylesheet" type="text/css" href="'. DFF_FP_URLPATH . 'style/user.featured.css' .'" />';
}
add_action('wp_head', 'DFF_WP_FP_sc_css');

$sc_counter = 0;

function DFF_WP_FP_shortcode_display($atts)
{
	global $sc_counter;
	global $DFF_API_obj;

	$sc_counter++;

	$params = shortcode_atts(Array(
		'corenum' => 0,
		'mernum' => 0,
		'mersku' => '',
		'mer_limit' => 5,
		'hide_desc' => false,
		'layout' => 'horizontal',
		'alignment' => 'left',
		'target_blank' => true
	), $atts);
	$params['hide_desc'] = (strtolower($params['hide_desc']) == 'true') ? true : false;
	$params['target_blank'] = (strtolower($params['target_blank']) == 'false') ? false : true;

	if (false == $DFF_WP_FP_server_url = get_option('DFF_WP_FP_server_url'))
		return '<p><strong>DFF Error:</strong> DFF Server URL is empty.</p>';

	if (false == $affid = get_option('DFF_WP_FP_affid'))
		return '<p><strong>DFF Error:</strong> DFF Affiliate ID has not be set.</p>';

	if ($token == '') $token = get_option('DFF_WP_FP_token');
	else 	return '<p><strong>DFF Error:</strong> DFF Token has not be set.</p>';

	$cache_key = 'feature' . $sc_counter;
	$output = wp_cache_get($cache_key);
	if ($output === false)
	{
		$sch = new DFF_WP_FeaturedProduct($DFF_API_obj, $affid, $token);
		$sch->processShortCode($params);
		$output = $sch->output;

		wp_cache_set($cache_key, $output, null, DFF_CACHE_TIME);
	}

	return $output;
}

?>
