<?php
/**************************************************************
*
**************************************************************/

include_once 'DFF_WP_plugin_api_head.php';

class DFF_WP_FeaturedProduct
{
	private $dff;
	private $dff_params;
	private $sc_params;
	private $css_file;

	public $output = '';


	function __construct($dff, $affid, $token)
	{
		$this->dff = $dff;
		$this->dff->set_affid($affid);
		$this->dff->set_token($token);
		$this->dff_params = Array();
	}

	public function processShortCode($sc_params)
	{
		if ($sc_params['corenum'] > 0)
		{
			$dff_params['product_sku'] = $sc_params['corenum'];
		}
		else
		{
			$dff_params['mernum'] = $sc_params['mernum'];
			$dff_params['mersku'] = $sc_params['mersku'];
		}
		
		$this->sc_params = $sc_params;
		$this->dff_params = $dff_params;
		
		$this->consumeWebServices();
		$this->generateHTML();
	}

	private function consumeWebServices()
	{
		$this->dff->post_request( ( ($this->sc_params['corenum'] > 0) ? DFF_PPC : DFF_MERPRDT ), $this->dff_params);
		$this->dff->convert_json_to_array();

		/*
		echo '<pre>';
		print_r($this->dff->result_array);
		echo '</pre>';
		*/
	}

	private function generateHTML()
	{
		if ($this->sc_params['corenum'] > 0)
		{
			$thumb = "<div id=\"dff_thumb\"><img src=\"{$this->dff->result_array['product_info']['thumbnail']['url']}\" height=\"{$this->dff->result_array['product_info']['thumbnail']['height']}\" width=\"{$prod_info['thumbnail']['width']}\" /></div>";
			$title = "<h3>{$this->dff->result_array['product_info']['prdtname']}</h3>";
			$desc = (!$this->dff_params['hide_desc']) ? "<p>{$this->dff->result_array['product_info']['shortdesc']}</p>" : '<br />';			
		
			$r = 1;
			$prices = '<table>';
			foreach ($this->dff->result_array['price_comparison'] AS $merchant)
			{
				$class = ($r % 2) ? "odd" : "even";
				$target = ($this->sc_params['target_blank']) ? ' target="_blank"' : null;

				$mer_price = '$' . number_format($merchant['merprice'], 2);
				$prices .= "<tr class=\"$class\">";
				$prices .= "<th><a$target href=\"{$merchant['prdtclickurl']}\">{$merchant['mername']}</a></th>";
				$prices .= "<td><a$target href=\"{$merchant['prdtclickurl']}\">$mer_price</a></td>";
				$prices .= "</tr>";

				if ($r >= $this->sc_params['mer_limit']) break;

				$r++;
			}
			$prices .= '</table>';
		}
		else
		{
			$thumb = "<div id=\"dff_thumb\"><img src=\"{$this->dff->result_array['imgurl']}\" height=\"80\" width=\"80\" /></div>";
			$title = "<h3>{$this->dff->result_array['shortdesc']}</h3>";
			$desc = (!$this->sc_params['hide_desc']) ? "<p>{$this->dff->result_array['longdesc']}</p>" : '<br />';

			$prdt_price = '$' . number_format($this->dff->result_array['prdtprice'], 2);
			$merimage = "http://cimages.datafeedfile.com/images/merimages/{$this->dff->result_array['mernum']}/{$this->dff->result_array['mernum']}_image1.gif";
			$prices = "<p>$prdt_price from <a href=\"{$this->dff->result_array['prdturl']}\">{$this->dff->result_array['mername']}</a></p>";
			$prices .= "<p><img src=\"$merimage\" /></p>";
		}

		$this->output .= "<div id=\"dff_featuredproduct\" class=\"{$this->sc_params['layout']} {$this->sc_params['alignment']}\">";
		if ($this->sc_params['layout'] === 'vertical')
			$this->output .= $title . $thumb . $desc . $prices;
		else
			$this->output .= $thumb . "<div id=\"dff_productinfo\">$title $desc $prices</div>";
		$this->output .= '<div class="attrib">Powered by <a href="http://www.datafeedfile.com/">DataFeedFile.com</a></div></div>';
	}
}

?>
