<?php

// look up for the path
require_once( dirname( dirname(__FILE__) ) .'/dialog-config.php');

global $wpdb;

// check for rights
if ( !is_user_logged_in() || !current_user_can('edit_posts') )
	wp_die(__("You are not allowed to be here"));

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<title>DataFeedFile.com Featured Product Shortcode Generator Plugin</title>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />

<script type="text/javascript" src="<?php _e(get_option('siteurl')); ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>
<script type="text/javascript" src="<?php _e(get_option('siteurl')); ?>/wp-includes/js/tinymce/utils/mctabs.js"></script>
<script type="text/javascript" src="<?php _e(get_option('siteurl')); ?>/wp-includes/js/tinymce/utils/form_utils.js"></script>
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script>
<script type="text/javascript" src="<?php _e(DFF_FP_URLPATH); ?>/tinymce/js/jquery.jWizard-0.4.js"></script>
<script type="text/javascript" src="<?php _e(DFF_FP_URLPATH); ?>/tinymce/js/trim.js"></script>
<script type="text/javascript">
$(document).ready(function() {
	$('#wizard').jWizard({
		hideCancelButton: true,
		events: {
			onStepChange: function(e, current, next) {
				current.find('.error').remove();
				
				var corenum = $('#dff_corenum').val().trim();
				var mernum = $('#dff_mernum').val().trim();
				var mersku = $('#dff_mersku').val().trim();
				var layout = $('#dff_layout').val();
				var alignment = $('#dff_alignment').val();
				var hide_desc = $('#dff_hide_desc').val();
				var mer_limit = $('#dff_mer_limit').val().trim();
				var target_blank = $('#dff_target_blank').val();
					
				if (current.attr('id') === 'dff_productinfo')
				{
					if (corenum === '')
					{
						if ( mernum === '' || mersku === '' )
						{
							current.append('<p class="error">Please enter either a DFF Core # OR a Merchant ID# and Product SKU.</p>');
							return false;
						}
						else if (isNaN(mernum))
						{
							current.append('<p class="error">Please enter either a valid Merchant #</p>');
							return false;
						}
					}
					else if (isNaN(corenum))
					{
						current.append('<p class="error">Please enter either a valid DFF Core #</p>');
						return false;
					}
					else if ( corenum != '' && mernum != '' && mersku != '' )
					{
						current.append('<p class="error">Please only enter a DFF Core # OR both a Merchant ID# and Product SKU.</p>');
						return false;
					}
					
					if (corenum <= 0)
					{
						$('#dff_displayinfo p:eq(3)').hide();
					}
					else
					{
						$('#dff_displayinfo p:eq(3)').show();
					}
				}
				else if (next.attr('id') === 'dff_confirmation')
				{
					var sc = '[DFF_WP_FP';
					if (corenum > 0)	sc += ' corenum="' + corenum + '"';
					else	sc += ' mernum="' + mernum + '" mersku="' + mersku + '"';
					sc += ' layout="' + layout + '"';
					if (layout == 'vertical')	sc += ' alignment="' + alignment + '"';
					sc += ' hide_desc="' + hide_desc + '"';
					if (mer_limit)	sc += ' mer_limit="' + mer_limit + '"';
					sc += ' target_blank="' + target_blank + '"';
					sc += "]";

					$('#dff_shortcode').text(sc);
				}

				return true;
			},
			onFinish: function() {
				window.tinyMCE.execInstanceCommand('content', 'mceInsertContent', false, $("#dff_shortcode").text());
				tinyMCEPopup.editor.execCommand('mceRepaint');
				tinyMCEPopup.close();
			}
		}
	});
	$('#dff_layout').change(function() {
		if (this.value == 'horizontal')
			$('#dff_alignment').attr('disabled', 'disabled');
		else
			$('#dff_alignment').removeAttr('disabled');
	});
});
</script>

<link rel="stylesheet" type="text/css" href="<?php _e(DFF_FP_URLPATH); ?>/tinymce/css/dialog.css" />

</head>

<body onload="tinyMCEPopup.executeOnLoad('init();');">

<div class="panel_wrapper">
	<div id="wizard">
		<div id="dff_productinfo" class="step" title="Product Information">
			<table>
			
			<tr>
				<th>DataFeedFile SKU#:</th>
				<td><input id="dff_corenum" name="corenum" type="text" /></td>
				<td><a href="http://www.datafeedfile.com/affiliate_search.php" target="_blank">Finder</a> | <a href="http://wiki.datafeedfile.com/FPdffSKU" target="_blank">What is this?</a></td>
			</tr>
			<tr><td class="spacer" colspan="3">-OR-</td></tr>
			<tr>
				<th>Merchant Number:</th>
				<td><input type="text" id="dff_mernum" /></td>
				<td rowspan="2"><a href="http://www.datafeedfile.com/affiliate_search.php" target="_blank">Finder</a> | <a href="http://wiki.datafeedfile.com/FPdffMerchantProducts" target="_blank">What is this?</a></td>
			</tr>
			<tr>
				<th>Merchant SKU#:</th>
				<td><input type="text" id="dff_mersku" /></td>
			</tr>
			
			</table>
		</div>
		<div id="dff_displayinfo" class="step" title="Display Information">
			<p>Select a layout:
				<select id="dff_layout">
					<option value="horizontal">Horizontal</option>
					<option value="vertical">Vertical</option>
				</select>
			</p>
			<p>Which side of the page should this be displayed on?
				<select id="dff_alignment" disabled="disabled">
					<option value="left">Left</option>
					<option value="right">Right</option>
				</select>
			</p>
			<p>Would you like a short description to be shown?
				<select id="dff_hide_desc">
					<option value="false">Yes</option>
					<option value="true">No</option>
				</select>
			</p>
			<p>Number of Stores to Display: <input type="text" id="dff_mer_limit" value="5" /></p>
			<p>Would you like any links clicked in this region to open a new page?
				<select id="dff_target_blank">
					<option value="true">Yes</option>
					<option value="false">No</option>
				</select>
			</p>
		</div>
		<div id="dff_confirmation" class="step" title="Confirmation">
			<p>Check the Generated Short-Code below to make sure it matches your expectations:</p>
			<code id="dff_shortcode"></code>
		</div>
	</div>
	<div style="clear: both;"></div>
</div>

</body>
</html>
